/***********************************************************
*                       pC/TFS 2.38b                       *
*                 a FREE - Tiny File System                *
*                                                          *
*           by Frank Goetze  -  www.embedded-os.de         *
************************************************************
*                    TFS_Port_Atmel_EE.h                   *
*                 EEPROM Atmel DECLARATIONS                *
***********************************************************/
#ifndef _TFS_Port_AT28_
 #define _TFS_Port_AT28_

 #include "../pC_TFS.h"

/*
************************************************************
*                       EE-TYPE DEFINE
************************************************************
*/
//#define AT28C010
//#define AT28C040
#define AT28LV010

/*
***********************************************************
*                  EE-TYPE SPEZIFIC DEFINES
***********************************************************
*/
#ifdef AT28C010
 #define TFS_PAGESIZE 128
#else 
 #ifdef AT28C040
  #define TFS_PAGESIZE 256
 #else
  #ifdef AT28LV010
   #define TFS_PAGESIZE 128
   #define TFS_START    0x50000000    // start of external EE for AT91SAM7SExx
   #define TFS_SIZE     0x00020000    // size of TFS (128kB)
  #else
   #error "unknown Atmel-EE type !"
  #endif
 #endif
#endif

/*
***********************************************************
*                     TFS-PORT PROTOTYPES
***********************************************************
*/
U08 TFSPort_Init(void);
U08 TFSPort_Write(U08 OS_HUGE *dest, OS_CONST U08 OS_HUGE *source, TFS_LONG length);
U08 TFSPort_Fill(U08 OS_HUGE *dest, U08 value, TFS_LONG length);

#endif

