/***********************************************************
*                       pC/TFS 2.38b                       *
*                 a FREE - Tiny File System                *
*            by Frank Goetze  -  www.embedded-os.de        *
************************************************************
*                  TFS_Port_SAMD21_RAM.c                   *
*              SAMD21 NOR Port - code in RAM               *
************************************************************
* Revision-Info:                                           *
*                                                          *
***********************************************************/
#include "../../inc/SAMD21/TFS_Port_SAMD21.h"

extern U32 TFSport_SAMD_pagesize;

/*
************************************************************
*             NVM-functions located in RAM
*
* see: KEIL example for this under
*      "/<your Keil folder>/ARM/Examples/RamFunction/"
************************************************************
*/
void TFSport_erase_page_RAMfunct(U08 OS_HUGE *page)
{
    NVMCTRL->ADDR.reg  = (U32)page >> 1;
    NVMCTRL->CTRLA.reg = NVMCTRL_CTRLA_CMDEX_KEY | NVMCTRL_CTRLA_CMD_ER;
    while(!NVMCTRL->INTFLAG.bit.READY) _NOP();
}

void TFSport_write_page_RAMfunct(U08 OS_HUGE *dest, OS_CONST U08 OS_HUGE *src)
{
    U08 i;

    NVMCTRL->CTRLB.bit.MANW = 1;
    for (i = 0; i < TFSport_SAMD_pagesize; i += sizeof(U32)) *(U32 *)(&dest[i]) = *(U32 *)(&src[i]);
    NVMCTRL->CTRLA.reg = NVMCTRL_CTRLA_CMDEX_KEY | NVMCTRL_CTRLA_CMD_WP;
    while(!NVMCTRL->INTFLAG.bit.READY) _NOP();
}

